module Scripting
  module AppDefaults

    def self.instance_init(instance, *args)
      instance.instance_eval do
        options do
          verbose false
          debug false
        end

        switches do
          on_tail('-v', '--verbose', 'Enable verbose output') do
            options.verbose = true
          end

          on_tail('-D', '--debug', 'Enable debug output') do
            options.debug = true
          end

          on_tail('-h', '--help', "Help text") do
            context.clear_work!
            context.help!
            terminate
          end
        end
      end
    end

  end
end
