module Scripting

  class Options
    def describe &blk; instance_eval &blk; end

    def [](name)
      ivar = "@#{name}"
      value = instance_variable_get(ivar)

      if value.respond_to? :call
        instance_eval &value
      else
        value
      end
    end

    def []=(name, value)
      ivar = "@#{name}"
      instance_variable_set(ivar, value)
    end

    def method_missing(name, *args, &blk)
      name = name.to_s

      # predicate?
      if name =~/\?$/
        return !!self[name.chop]
      end

      # assignment=
      if name =~ /=$/
        name.chop!
      end

      if block_given?
        self[name] = blk
      elsif args.length > 0
        self[name] = args.first
      else
        self[name]
      end
    end
  end
end