require 'forwardable'
require 'delegate'
require 'optparse'

module Scripting
  #TODO: flesh this out... We can, ideally, use any options parser but by default we use optparse.
  def self.CustomParser(klass)
    custom = Class.new(DelegateClass(klass))
    custom.class_eval do
      extend Forwardable
      def_delegators :@context, :context, :options
      def describe; instance_eval; end
    end

    custom.send(:define_method, :initialize) do |context|
      @context = context
      super(klass.new)
    end

    custom
  end

  Parser = Scripting::CustomParser(OptionParser)
end